package net.peachjean.guice.command;

import com.google.inject.Binder;
import com.google.inject.TypeLiteral;
import com.google.inject.binder.LinkedBindingBuilder;
import com.google.inject.multibindings.MapBinder;
import com.google.inject.util.Types;

import java.lang.reflect.Type;

public interface ArgResolver<T> {
	T resolve(ArgIterator argIterator, Type type);

	public static class Registry {
		static final TypeLiteral<Class<?>> KEY_TYPE = createKeyType();
		static final TypeLiteral<ArgResolver> VALUE_TYPE = TypeLiteral.get(ArgResolver.class);

		@SuppressWarnings({"unchecked"})
		private static TypeLiteral<Class<?>> createKeyType() {
			return (TypeLiteral<Class<?>>) TypeLiteral.get(Types.newParameterizedType(Class.class, Types.subtypeOf(Object.class)));
		}

		private Registry() {
			// uninstantiable
		}

		public static LinkedBindingBuilder<ArgResolver> bind(Binder binder, Class<?> type) {
			return MapBinder.newMapBinder(binder, KEY_TYPE, VALUE_TYPE).addBinding(type);
		}
	}
}