package net.peachjean.guice.command;

import net.peachjean.guice.command.Option;

import java.lang.annotation.Annotation;

class OptionImpl implements Option {

	private String value;

	public OptionImpl(String value) {
		this.value = value;
	}

	@Override
	public String value() {
		return value;
	}

	@Override
	public boolean equals(Object o) {
		return o instanceof Option && ((Option) o).value().equals(value());
	}

	@Override
	public int hashCode() {
		return (127 * "value".hashCode()) ^ value.hashCode();
	}

	@Override
	public String toString() {
		return String.format("<Option %s>", value());
	}

	@Override
	public Class<? extends Annotation> annotationType() {
		return Option.class;
	}
}
