package net.peachjean.guice.command;

import com.google.inject.Binder;
import com.google.inject.Injector;
import com.google.inject.Key;
import com.google.inject.binder.AnnotatedBindingBuilder;
import com.google.inject.binder.LinkedBindingBuilder;

public class Options {

	public static Option forName(String name) {
		return new OptionImpl(name);
	}

	public static <T> void bind(Binder binder, OptionInfo<T> optionInfo) {
		binder.bind(OptionInfo.class).annotatedWith(new OptionImpl(optionInfo.name)).toInstance(optionInfo);
	}

	public static LinkedBindingBuilder bindAsOption(AnnotatedBindingBuilder bind, String name) {
		return bind.annotatedWith(new OptionImpl(name));
	}

	@SuppressWarnings({"unchecked"})
	public static <T> OptionInfo<T> lookupInfo(Injector injector, String name) {
		return (OptionInfo<T>) injector.getInstance(Key.get(OptionInfo.class, new OptionImpl(name)));
	}
}
