package net.peachjean.guice.command.invoke;

import com.google.common.collect.Iterables;
import com.google.inject.Guice;
import com.google.inject.Injector;
import com.google.inject.Module;
import net.peachjean.guice.command.invoke.args.ArgResolverModule;

import java.util.Arrays;


public class CommandInvokerFactory {
	private CommandInvokerFactory() {
		// non-instantiable
	}

	public static CommandInvoker createInvoker(Iterable<? extends Module> modules) {
		CommandRegistry commandRegistry = new CommandRegistryBuilder().buildCommandRegistry(modules);
		Injector injector = Guice.createInjector(Iterables.concat(modules,
		                                                          Arrays.asList(new InvokeModule(commandRegistry), new ArgResolverModule())));
		return injector.getInstance(CommandInvoker.class);

	}
}
