package net.peachjean.guice.command.invoke;

import com.google.common.collect.Multimap;
import com.google.common.collect.Sets;

import java.util.Collection;
import java.util.Map;
import java.util.Set;

class CommandRegistry {
	private Map<String, CommandDescriptor> descriptorMap;
	private Multimap<String, OptionKey<?>> commandOptions;
	private Set<OptionKey> allOptions;

	public CommandRegistry(Map<String, CommandDescriptor> descriptorMap, Multimap<String, OptionKey<?>> commandOptions) {
		this.descriptorMap = descriptorMap;

		this.commandOptions = commandOptions;
		this.allOptions = Sets.newLinkedHashSet();
		this.allOptions.addAll(commandOptions.values());
	}

	public Map<String, CommandDescriptor> getDescriptorMap() {
		return descriptorMap;
	}

	public Collection<OptionKey<?>> getApplicableOptions(String command) {
		return commandOptions.get(command);
	}

	public Set<OptionKey> getAllOptions() {
		return allOptions;
	}
}
