package net.peachjean.guice.command.invoke;

import com.google.inject.Key;
import net.peachjean.guice.command.CommandScoped;

import java.io.InputStream;
import java.io.PrintStream;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

@CommandScoped
class GuiceAppContext {
	final InputStream in;
	final PrintStream out;
	final PrintStream err;
	String[] args;
	volatile ConcurrentMap<Key<?>, Object> scopedObjects = new ConcurrentHashMap<Key<?>, Object>();

	public GuiceAppContext(InputStream in, PrintStream out, PrintStream err, String[] args) {
		this.in = in;
		this.out = out;
		this.err = err;
		this.args = args;
	}

	public GuiceAppContext(CommandInvocation commandInvocation) {
		this(commandInvocation.in, commandInvocation.out, commandInvocation.err, commandInvocation.args);
	}
}