package net.peachjean.guice.command.invoke;

class OptionKey<T> {
	final String name;
	final Class<T> type;

	OptionKey(String name, Class<T> type) {
		this.name = name;
		this.type = type;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}

		OptionKey optionKey = (OptionKey) o;

		if (name != null ? !name.equals(optionKey.name) : optionKey.name != null) {
			return false;
		} else if (type != null ? !type.equals(optionKey.type) : optionKey.type != null) {
			return false;
		} else {
			return true;
		}
	}

	@Override
	public int hashCode() {
		int result = name != null ? name.hashCode() : 0;
		result = 31 * result + (type != null ? type.hashCode() : 0);
		return result;
	}
}
