package net.peachjean.guice.command.invoke;

import com.google.inject.Provider;
import net.peachjean.guice.command.OptionInfo;

class OptionProvider<T> implements Provider<T> {
	private OptionKey<T> optionKey;
	private Provider<CommandParser> parserProvider;
	private Provider<OptionInfo<T>> optionInfoProvider;

	public OptionProvider(OptionKey optionKey, Provider<CommandParser> parserProvider) {

		this.optionKey = optionKey;
		this.parserProvider = parserProvider;
		this.optionInfoProvider = optionInfoProvider;
	}

	@Override
	public T get() {
		return parserProvider.get().provideOptionValue(optionKey);
	}
}
