package net.peachjean.guice.command.invoke.args;

import com.google.inject.AbstractModule;
import net.peachjean.guice.command.ArgResolver;

import java.lang.reflect.Array;
import java.util.Collection;
import java.util.List;
import java.util.Set;

public class ArgResolverModule extends AbstractModule {

	public ArgResolverModule() {
	}

	@Override
	protected void configure() {
		ArgResolver.Registry.bind(binder(), Array.class).toInstance(ArrayArgResolver.INSTANCE);
		ArgResolver.Registry.bind(binder(), Object.class).toInstance(SingleArgResolver.INSTANCE);

		ArgResolver.Registry.bind(binder(), List.class).toInstance(ListArgResolver.INSTANCE);
		ArgResolver.Registry.bind(binder(), Iterable.class).toInstance(ListArgResolver.INSTANCE);
		ArgResolver.Registry.bind(binder(), Collection.class).toInstance(ListArgResolver.INSTANCE);
		ArgResolver.Registry.bind(binder(), Set.class).toInstance(SetArgResolver.INSTANCE);
	}
}
