package net.peachjean.guice.command.invoke.args;

import net.peachjean.guice.command.ArgIterator;
import net.peachjean.guice.command.ArgResolver;

import java.lang.reflect.Array;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.List;

class ArrayArgResolver implements ArgResolver {

	static ArgResolver INSTANCE = new ArrayArgResolver();

	@Override
	public Object resolve(ArgIterator argIterator, Type type) {
		final Class componentType = ((Class) type).getComponentType();
		List<Object> args = new ArrayList<Object>();
		while (argIterator.hasMoreArgs()) {
			args.add(argIterator.next(componentType));
		}
		Object argArray = Array.newInstance(componentType, args.size());
		for (int i = 0; i < args.size(); i++) {
			Array.set(argArray, i, args.get(i));
		}
		return argArray;
	}
}
